   domains
      number = integer
      list   = integer *
   predicates
      read_list (list)
      write_list (list)
      copy_list (list,list)
      sum_list (list,number)
      find_n (number,list,number)
      append (list,list,list)
      reverse (list,list)
      trance (list,list,list)
      delete (number,list,list)
      listmax (list,number)
      greater (number,number,number)
   goal
      write ("  ᯨ᪠... "),
      read_list (Lst), nl,
      write (" ... "), write_list (Lst), nl,
      /* ------------------------------------------- */
      write (" ᯨ᪠... "), copy_list (Lst,Lst1),
      write_list (Lst1), nl,
      /* -------------------------------------- */
      write ("⢮ ⮢  ᯨ᪥... "),
      sum_list (Lst,X1), write (X1), nl,
      /* ---------------------------------------------- */
      write ("饬  ᯨ᪥    p."),
      write (" p: "),
      readint (N), find_n (N,Lst1,T), write (T), nl,
      /* ---------------------------------------- */
      write ("  ᯨ᪠... "),
      append (Lst,Lst1,Lst2), write_list (Lst2), nl,
      /* ---------------------------------------- */
      write ("p⨬  ᯨ᮪."),
      write ("  ᯨ᪠... "),
      read_list (Lst3), nl, reverse (Lst3,Lst4),
      write_list (Lst4), nl,
      /* --------------------------------------- */
      write ("  ᯨ᪠  ."),
      write (" ... "),
      readint (U), delete (U,Lst4,Lst5),
      write_list (Lst5), nl,
      write ("  ᫮ ᯨ᪥ 訩 . "),
      listmax (Lst5,A), write (A), nl.
   clauses
     /* ------------------------------------ */
     /*  ᯨ᪠ 楫 ᥫ  p */
     /* ------------------------------------ */
      read_list ([H|T]):-
                           readint (H), !, read_list (T).
      read_list ([]).
     /* ----------------------------------------- */
     /* 뢮 ᯨ᪠ 楫 ᥫ  p ᯫ */
     /* ----------------------------------------- */
      write_list ([]).
      write_list ([Head|Tail]) :-
                           write (Head), write (" "),
                           write_list (Tail).
     /* ------------------------------ */
     /* p ᯨ᪠ 楫 ᥫ */
     /* ------------------------------ */
      copy_list ([],[]).
      copy_list ([Head|Tail],[Head|Tail1]) :-
                           copy_list (Tail,Tail1).
     /* (DEFUN COPY (LAMBDA (LST)                        */
     /*    (COND ( (NULL LST) NIL )                      */
     /*          ( T (CONS (CAR LST) (COPY (CDR LST))) ) */
     /*    )                                             */
     /* ))                                               */
     /* ---------------------------------- */
     /* p ⢠ ⮢  */
     /*       ᯨ᪥ 楫 ᥫ           */
     /* ---------------------------------- */
      sum_list ([],0).
      sum_list ([_|T],Sum) :-
                           sum_list (T,Sum1),
                           Sum = 1 + Sum1.
     /* (DEFUN LENGTH (LAMBDA (LST)                     */
     /*    (COND ( (NULL LST) 0 )                       */
     /*          (  T  (+ 1 (LENGTH (CDR LST))) ))))    */
     /* -------------------------------------- */
     /* H宦  ᯨ᪠  p N */
     /* -------------------------------------- */
      find_n (N,LST,100):-
                           sum_list (LST,V),N>V.
      find_n (N,_,-100):-
                           N<=0.
      find_n (1,[Head|_],Head).
      find_n (Middle,[_|Tail],Z) :-
                           Middle1 = Middle - 1,
                           find_n (Middle1,Tail,Z).
     /* (DEFUN NTH (LAMBDA (N LST)                   */
     /*    (COND ( (> N (LENGTH LST))   100 )        */
     /*          ( (OR (< N 0) (ZEROP N)) -100 )     */
     /*          ( (EQ N 1) (CAR LST) )              */
     /*          (  T  (NTH (- N 1)                  */
     /*                     (CDR LST)) ))))          */
     /* ------------------------- */
     /* ""  ᯨ᪮ */
     /* ------------------------- */
      append ([],L,L).
      append ([N|L1],L2,[N|L3]) :-
                           append (L1,L2,L3).
     /* ------------------------------------- */
     /*   ᯨ᪠   */
     /* ------------------------------------- */
      delete (_,[],[]).
      delete (X,[X|Tail],List) :-
                           delete (X,Tail,List).
      delete (X,[Z|Tail],[Z|V]):-
                           delete (X,Tail,V).
     /* (DEFUN DELETE (LAMBDA (X LST)                   */
     /*    (COND ( (NULL LST) NIL )                     */
     /*          ( (EQ (CAR LST) X)                     */
     /*                      (DELETE X (CDR LST)) )     */
     /*          (  T  (CONS (CAR LST)                  */
     /*                      (DELETE X (CDR LST))) )))) */
     /* --------------------------- */
     /* "" ⮢ ᯨ᪠ */
     /* --------------------------- */
      reverse (L,Z)            :-
                           trance (L,[],Z).
      trance ([],Result,Result).
      trance ([X|Y],Result,Z)  :-
                           trance (Y,[X|Result],Z).
     /* -------------------------------------------- */
     /*  襣   ᫮ ᯨ᪥ */
     /* -------------------------------------------- */
      listmax ([X|[]],X).
      listmax ([X|Y],Z) :-
                           listmax (Y,V), greater (X,V,Z).
      greater (X,Y,X)   :- X>Y.
      greater (X,Y,Y)   :- X<=Y.
   /*   pp  */
